//+------------------------------------------------------------------+
//|                                                    H4-SYSTEM.mq4 |
//|                                         Copyright  2007, DMBSYS |
//|                                           http://www.dmbsys.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, DMBSYS"
#property link      "http://www.dmbsys.net/"

extern int Lots = 1;
extern int Trailing = 30;

extern string Parameters="Parameters values";
extern int ShiftVal = 0;

extern double Step = 0.002;
extern double Maximum = 0.2;
extern int Precision = 5;

int OpenOrders, cnt;
double pricestart, StopLoss;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----

      double SARbuyC    = iCustom(NULL,0,"SAR Color Bar",Step,Maximum,Precision,1,ShiftVal);
      double SARsellC   = iCustom(NULL,0,"SAR Color Bar",Step,Maximum,Precision,0,ShiftVal);

      double SARbuyP    = iCustom(NULL,0,"SAR Color Bar",Step,Maximum,Precision,1,ShiftVal+1);
      double SARsellP   = iCustom(NULL,0,"SAR Color Bar",Step,Maximum,Precision,0,ShiftVal+1);
          
   OpenOrders=0;
      
	for(cnt=0;cnt<OrdersTotal();cnt++)
	{
	  OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol()==Symbol()) 
	  {		
	     if (OrderStopLoss()!=0) { pricestart=OrderStopLoss(); } else { pricestart=OrderOpenPrice(); }	
			if (OrderType()==OP_BUY) 
			{			
            if (pricestart+(MathRound(Trailing*1.5))*Point<Bid)
            {
               StopLoss=pricestart+Trailing*Point;
               OrderModify(OrderTicket(),0,StopLoss,0,0,Yellow);
            }
			}
			if (OrderType()==OP_SELL) 
			{
            if (pricestart-(MathRound(Trailing*1.5))*Point>Ask)
            {
               StopLoss=pricestart-Trailing*Point;
               OrderModify(OrderTicket(),0,StopLoss,0,0,Yellow);
            }
  			}
  		   OpenOrders++; 
	  }
   }      

/*
      double SARbuyC    = iCustom(NULL,0,"SAR Color Bar",Step,Maximum,Precision,1,ShiftVal);
      double SARsellC   = iCustom(NULL,0,"SAR Color Bar",Step,Maximum,Precision,0,ShiftVal);

      double SARbuyP    = iCustom(NULL,0,"SAR Color Bar",Step,Maximum,Precision,1,ShiftVal+1);
      double SARsellP   = iCustom(NULL,0,"SAR Color Bar",Step,Maximum,Precision,0,ShiftVal+1);
*/

   if (OpenOrders==0)
   {
         if (SARbuyC>0 && SARsellP>0)
         {
            OrderSend(Symbol(),OP_BUY,Lots,Ask,2,0,0,"H4sys",1234,0,Blue);
            return(0);
         }
         if (SARsellC>0 && SARbuyP>0)
         {
            OrderSend(Symbol(),OP_SELL,Lots,Bid,2,0,0,"H4sys",1234,0,Red);  
            return(0);
         }
   }      	            
//----
   return(0);
  }
//+------------------------------------------------------------------+

